import 'package:fis_common/logger/logger.dart';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_trace_measure.dart';
import 'package:fis_measure/process/workspace/urm/application.dart';
import 'package:vid/us/vid_us_unit.dart';

class URMTraceHistCal extends URMTraceMeasureCal {
  URMTraceHistCal(super.ref);

  @override
  void calculate() {}

  @override
  Future<void> calculateAsync() async {
    super.handleURMSimpleMeasureParams();
    try {
      if (ref.feature == null) return;
      if (ref.application is! URMApplication) return;
      final URMApplication urmApplication = ref.application as URMApplication;

      URMMeasureProcessResult? outresult =
          await urmApplication.getURMMeasureResult(
        urmMeasureType: URMMeasureType.URMHist,
        rOIType: URMROIType.URMTrace,
        srcDPoints: param!.srcDPoints,
      );
      if (outresult == null) {
        return;
      }
      final feature = ref.feature!;

      /// TODO 只转数据类型还不够，需要将 视图区域百分比坐标转为全图百分比坐标

      final first = ref.meta.outputs.first;
      first.unit = VidUsUnit.None;

      /// 超声机上面注释掉了
      // feature.updateFloatValue(first, outresult.resultData, first.unit);
    } catch (e) {
      logger.e('URM Measure error: $e');
      return;
    }
    ref.application.updateRenderReady.emit(this, null);
  }
}
