import 'package:fis_measure/interfaces/process/items/item.dart';
import 'package:fis_measure/interfaces/process/items/item_metas.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_den_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_den_vel_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_density_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_fractal_dim_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_hist_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_perfusion_measure.dart';
import 'package:fis_measure/process/calcuators/urm_calcuators/urm_shell_vel_measure.dart';
import 'package:fis_measure/process/primitives/trace.dart';

class URMShellMeasure extends Trace {
  URMShellMeasure(super.meta, super.parent);

  static URMShellMeasure createURMShellDenMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellDen = URMShellMeasure(meta, parent);
    measureShellDen.calculator = URMShellDenMeasureCal(
      measureShellDen,
    );
    return measureShellDen;
  }

  static URMShellMeasure createURMShellVelMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellVel = URMShellMeasure(meta, parent);
    measureShellVel.calculator = URMShellVelMeasureCal(
      measureShellVel,
    );
    return measureShellVel;
  }

  static URMShellMeasure createURMShellDensityMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellDensity = URMShellMeasure(meta, parent);
    measureShellDensity.calculator = URMShellDensityMeasureCal(
      measureShellDensity,
    );
    return measureShellDensity;
  }

  static URMShellMeasure createURMShellFractalDimMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellFractalDim = URMShellMeasure(meta, parent);
    measureShellFractalDim.calculator = URMShellFractalDimMeasureCal(
      measureShellFractalDim,
    );
    return measureShellFractalDim;
  }

  static URMShellMeasure createURMShellPerfusionMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellPerfusion = URMShellMeasure(meta, parent);
    measureShellPerfusion.calculator = URMShellPerfusionMeasureCal(
      measureShellPerfusion,
    );
    return measureShellPerfusion;
  }

  static URMShellMeasure createURMShellHistMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellHist = URMShellMeasure(meta, parent);
    measureShellHist.calculator = URMShellHistMeasureCal(
      measureShellHist,
    );
    return measureShellHist;
  }

  static URMShellMeasure createURMShellDenVelMeasure(ItemMeta meta,
      [IMeasureItem? parent]) {
    URMShellMeasure measureShellDenVel = URMShellMeasure(meta, parent);
    measureShellDenVel.calculator = URMShellDenVelMeasureCal(
      measureShellDenVel,
    );
    return measureShellDenVel;
  }
}
